package net.library.jiga.sf3.game;

import net.library.jiga.sf3.*;
import java.applet.Applet;
import java.awt.*;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.RandomAccessFile;
import java.lang.ref.ReferenceQueue;
import javax.imageio.ImageIO;
import javax.media.jai.GraphicsJAI;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.util.*;
import java.security.AccessControlException;
import java.io.File;
import java.io.IOException;
import net.library.jiga.installer.AntApplet;
import net.library.jiga.installer.AppLauncher;
import net.library.jiga.installer.FileChooserPane;
import net.library.jiga.installer.LogArea;
import net.library.jiga.installer.UIMessage;
import org.jdesktop.swingx.JXImagePanel;
import org.jdesktop.swingx.JXPanel;
import org.jdesktop.swingx.JXTaskPane;
import org.jdesktop.swingx.JXTaskPaneContainer;
import org.jdesktop.swingx.JXTitledPanel;
import net.library.jiga.sf3.system.SfMediaTracker;
import net.library.jiga.sf3.system.SpritesCacheListener;
import net.library.jiga.sf3.system.SpritesCacheManager;

/**
 * ActiveApplet sub-class to load animation browser. It uses Animation object as main thread. Double Buffering is implemented in refresh Timer.
 * @discussion  (comprehensive description)
 */
public class AnimsBrowser_Ant extends JApplet implements AntApplet, RenderingSceneListener {

    private JTextField sw_chr_name;
    private JSpinner sw_chr_floor;
    private JSpinner sw_chr_dim_ext_w,  sw_chr_dim_ext_h;
    private JSpinner sw_chr_dim_int_w,  sw_chr_dim_int_h;
    private int resolution;
    int buffers = 3;
    SpritesCacheManager mainCache = new SpritesCacheManager<Object, Object>();
    JComponent spot;
    Rectangle box;
    Animation currentAnim;
    MediaTracker mt;
    SpritesChar character = SpritesChar.getCustomSpritesChar(SpritesChar.LOW);
    String spritesDir = null, spritesExt = null, sfxDir = null, sfxExt = null;
    HashSet listeners = new HashSet();
    // soft double Buffering
    BufferedImage offscreen;
    Color bgColor = Color.BLUE;
    int mirror = Animation.NONE;
    JLabel mirror_str;
    double position = 0.0;
    boolean reverse = false;
    JLabel reverse_str;
    double zoom = 1.0;
    boolean swap = true;
    JLabel swap_str;
    boolean compress = false;
    JLabel compress_str;
    boolean OpenGLMode = false;
    // components
    JXTaskPane panel;
    JButton /*sw_character, */ sw_mirror_orientation;
    //JCheckBox sw_hardwareMode, sw_mirror, sw_reverse, sw_sound, sw_custom, sw_swapDisk, sw_compress, sw_openGL;
    JSpinner sw_anim, sw_sfx;
    JSlider sw_position, sw_zoom;
    JButton sw_refresh;
    //JButton sw_directory, sw_directory_sfx;
    JButton sw_bgColor;
    FileChooserPane dirSelect;
    JButton sw_animID, sw_IDAnim, sw_IDSfx;
    LogArea sw_log;
    //JButton sw_clearLog;
    JButton sw_printAnimsID;
    JTextField sw_formatPrintID, sw_formatPrintSfxID;
    //JButton sw_play, sw_pause, sw_previous, sw_next, sw_rewind, sw_load, sw_cancel, sw_init;
    JButton sw_anim_input;
    JTextField sw_anim_input_start;
    JLabel sw_state;
    JProgressBar statusBar;
    String format;
    ReferenceQueue refQueue = new ReferenceQueue();
    javax.swing.JTextField sw_anim_input_end, sw_anim_input_size_width;
    JButton sw_anim_add;
    Stack<JTextField> sw_anim_added_st = new Stack<JTextField>();
    Stack<JTextField> sw_anim_added_end = new Stack<JTextField>();
    Stack<JTextField> sw_sfx_added = new Stack<JTextField>();
    JXPanel panelCustom;
    javax.swing.JTextField sw_anim_input_size_height;
    JButton sw_sfx_add;
    javax.swing.JTextField sw_anim_input_prefix, sw_anim_input_suffix, sw_sfx_input;
    JPanel modelPanel;
    RenderingScene scene;
    String[] animsID;
    String[] sfxID;
    String[] reversedAnims;
    SpritesCacheManager<Integer, Animation> model;
    boolean initialized = false;
    Thread t_activity;

    /**
     * Applet initialization
     * @discussion All Swing components are loaded and added to applet content. A config panel is instanced throughout a new JFrame.
     */
    public void init() throws HeadlessException {
        if (initialized) {
            return;
        }
        setLayout(new BorderLayout());
        mainCache.setSwapDiskEnabled(false);
        mainCache.setCompressionEnabled(false);
        mainCache.setAutoCleanupEnabled(true);
        /* UI select sprites directory */
        /* ---- */
        try {
            String[] result = new String[2];
            while ((result = getDirectory()) == null) {
                ;
            }
            spritesDir = result[0];
            spritesExt = result[1];
            resolution = getResolution();

            // model panel

            modelPanel = new JPanel(true);
            modelPanel.setLayout(new GridBagLayout());

            final JScrollPane sp = new JScrollPane();
            sp.add(modelPanel);
            sp.setSize((int) (getSize().width / 3), getSize().height);
            add(sp, BorderLayout.EAST);

            JXTaskPaneContainer XContainer = new JXTaskPaneContainer();

            // controller panel
            JXPanel controller = new JXPanel(true);
            controller.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(), "controller", TitledBorder.RIGHT, TitledBorder.TOP));
            controller.setLayout(new BorderLayout());
            controller.add(this.sw_refresh = new JButton("refresh"), BorderLayout.SOUTH);
            sw_refresh.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    sw_refresh.setText("refreshing...");
                    sw_anim.setModel(new SpinnerNumberModel(getCurrentAnim(), 0, character.frames.length - 1, 1));
                    sw_sfx.setModel(new SpinnerNumberModel(((SpinnerNumberModel) sw_sfx.getModel()).getNumber().intValue(), 0, character.sfx.length - 1, 1));
                    refreshSpot();
                    sw_refresh.setText("refreshed");
                }
            });

            controller.add(statusBar = new JProgressBar(0, 100), BorderLayout.CENTER);
            statusBar.addChangeListener(new ChangeListener() {

                public void stateChanged(ChangeEvent changeEvent) {
                    statusBar.update(statusBar.getGraphics());
                }
            });
            add(controller, BorderLayout.SOUTH);

            // config panel
            panel = new JXTaskPane();
            panel.setExpanded(false);
            XContainer.add(panel);
            // init data to config
            initData();

            // play panel
            JXTaskPane panelPlay = new JXTaskPane();
            panelPlay.setTitle("Animation Player");
            panelPlay.setExpanded(false);
            XContainer.add(panelPlay);
            final AbstractAction action_play = new AbstractAction("play (ALT+P)") {

                public void actionPerformed(ActionEvent e) {
                    if (currentAnim != null) {
                        currentAnim.play();
                    }
                }
            };

            panelPlay.add(action_play);

            panelPlay.add(new AbstractAction("pause") {

                public void actionPerformed(ActionEvent e) {
                    if (currentAnim != null) {
                        currentAnim.pause();
                    }
                }
            });

            panelPlay.add(new AbstractAction("backwards") {

                public void actionPerformed(ActionEvent e) {
                    if (currentAnim != null) {
                        currentAnim.previous();
                    }
                }
            });
            panelPlay.add(new AbstractAction("forwards") {

                public void actionPerformed(ActionEvent e) {
                    if (currentAnim != null) {
                        currentAnim.next();
                    }
                }
            });

            panelPlay.add(new AbstractAction("rewind") {

                public void actionPerformed(ActionEvent e) {
                    if (currentAnim != null) {
                        currentAnim.rewind();
                    }
                }
            });
            panelPlay.add(new JLabel("_____"));
            panelPlay.add(sw_state = new JLabel("No state"));
            panelPlay.add(new AbstractAction("play soundfx") {

                public void actionPerformed(ActionEvent e) {
                    currentAnim.playSfx();
                }
            });

            // character customization params

            panel.add(new AbstractAction("switch resolution...") {

                public void actionPerformed(ActionEvent e) {
                    resolution = getResolution();
                }
            });

            panel.add(new AbstractAction("switch image type...") {

                public void actionPerformed(ActionEvent e) {
                    format = getFormat();
                }
            });

            panel.add(new AbstractAction("switch background...") {

                public void actionPerformed(ActionEvent e) {
                    bgColor = getColor();
                }
            });

            panel.add(new AbstractAction("load demo/uncompleted character \n\r(you will lose your current customized data)...") {

                public void actionPerformed(ActionEvent actionEvent) {
                    character = getSpritesChar();
                    reset();
                }
            });
            final AbstractAction action_setDirectory = new AbstractAction("set sprites directory...") {

                public void actionPerformed(ActionEvent e) {
                    String[] result = getDirectory();
                    spritesDir = result[0];
                    spritesExt = result[1];
                }
            };
            panel.add(action_setDirectory);

            JPanel panelSelectAnim;
            add(panelSelectAnim = new JXPanel(true), BorderLayout.NORTH);
            panelSelectAnim.setLayout(new GridBagLayout());
            GridBagConstraints c = new GridBagConstraints();
            panelSelectAnim.add(new JLabel("Select animation: (ALT + UP or DOWN)"));
            panelSelectAnim.add(this.sw_anim = new JSpinner(new SpinnerNumberModel(0, 0, (character != null) ? character.frames.length - 1 : 100, 1)));
            sw_anim.addChangeListener(new ChangeListener() {

                public void stateChanged(ChangeEvent e) {
                    System.out.println("anim changed");
                    loadAnim(mt, getSfx());
                    refreshSpot();
                }
            });
            c.gridwidth = GridBagConstraints.REMAINDER;
            ((GridBagLayout) panelSelectAnim.getLayout()).setConstraints(sw_anim, c); // new line with c gridbagconstraints gridwidth remainder
            panelSelectAnim.add(new JLabel("Select animation sfx:"));
            panelSelectAnim.add(this.sw_sfx = new JSpinner(new SpinnerNumberModel(0, 0, (character != null) ? character.sfx.length - 1 : 100, 1)));
            sw_sfx.addChangeListener(new ChangeListener() {

                public void stateChanged(ChangeEvent e) {
                    System.out.println("sfx changed");
                    currentAnim.setSfx(getSfx(), false, 0);
                }
            });
            c.gridwidth = GridBagConstraints.REMAINDER;
            ((GridBagLayout) panelSelectAnim.getLayout()).setConstraints(sw_sfx, c); // new line with c gridbagconstraints gridwidth remainder
            panelSelectAnim.add(new JLabel("timeframe:"));
            panelSelectAnim.add(sw_position = new JSlider(0, 100, 0));
            sw_position.setPaintTrack(true);
            sw_position.addChangeListener(new ChangeListener() {

                public void stateChanged(ChangeEvent e) {
                    position = sw_position.getValue() / 100.0;
                    if (currentAnim != null) {
                        currentAnim.position((int) (position * currentAnim.length));
                    }
                    System.out.println("position changed");
                }
            });
            c = new GridBagConstraints();
            c.gridwidth = GridBagConstraints.REMAINDER;
            ((GridBagLayout) panelSelectAnim.getLayout()).setConstraints(sw_position, c);

            panelSelectAnim.add(sw_zoom = new JSlider(0, 200, 100));
            Dictionary labels_zm = new Hashtable();
            for (int i = 0; i <= 200; i = i + 50) {
                labels_zm.put(new Integer(i), new JLabel(i / 100.0 + "x"));
            }
            sw_zoom.setLabelTable(labels_zm);
            sw_zoom.setPaintLabels(true);
            sw_zoom.setPaintTicks(true);
            sw_zoom.setSnapToTicks(true);
            sw_zoom.setMajorTickSpacing(50);
            sw_zoom.setMinorTickSpacing(25);
            sw_zoom.addChangeListener(new ChangeListener() {

                public void stateChanged(ChangeEvent e) {
                    zoom = sw_zoom.getValue() / 100.0;
                    currentAnim.setZoomEnabled(true, zoom);
                    System.out.println("zoom changed");
                }
            });
            c = new GridBagConstraints();
            c.gridwidth = GridBagConstraints.REMAINDER;
            ((GridBagLayout) panelSelectAnim.getLayout()).setConstraints(sw_zoom, c);

            final AbstractAction action_setSFXDirectory = new AbstractAction("set SFX directory...") {

                public void actionPerformed(ActionEvent e) {
                    String[] result = getDirectory();
                    sfxDir = result[0];
                    sfxExt = result[1];
                }
            };
            panel.add(action_setSFXDirectory);



            panel.add(new AbstractAction("clear log") {

                public void actionPerformed(ActionEvent e) {
                    sw_log.clearLog();
                }
            });
            panel.add(new AbstractAction("reset") {

                public void actionPerformed(ActionEvent actionEvent) {
                    reset();
                }
            });
            panel.add(new AbstractAction("load") {

                public void actionPerformed(ActionEvent e) {
                    Thread t = new Thread(new Runnable() {

                        public void run() {
                            loadAnim(mt, getSfx());
                        }
                    }, "T-load-anim" + getCurrentAnim());
                    t.setPriority(Thread.MAX_PRIORITY);
                    t.start();
                }
            });

            panel.add(new AbstractAction("load from .sc3 file...") {

                public void actionPerformed(ActionEvent e) {
                    loadCustom();
                }
            });
            panel.add(new AbstractAction("cancel loading") {

                public void actionPerformed(ActionEvent e) {
                    currentAnim.cancel();
                }
            });

            JXTaskPane panelCache = new JXTaskPane();
            panelCache.setExpanded(false);
            XContainer.add(panelCache);
            panelCache.setTitle("Cache");
            panelCache.add(new AbstractAction("swap cache to disk") {

                public void actionPerformed(ActionEvent e) {
                    swap = (swap) ? false : true;
                    currentAnim.setSwapDiskCacheEnabled(swap);
                    swap_str.setText((swap) ? "enabled" : "disabled");
                }
            });
            panelCache.add(swap_str = new JLabel((swap) ? "enabled" : "disabled"));

            panelCache.add(new AbstractAction("sprites compressed") {

                public void actionPerformed(ActionEvent e) {
                    compress = (compress) ? false : true;
                    currentAnim.setCompressedCacheEnabled(compress);
                    compress_str.setText((compress) ? "enabled" : "disabled");
                }
            });
            panelCache.add(compress_str = new JLabel((compress) ? "enabled" : "disabled"));

            JXTaskPane panelFX = new JXTaskPane();
            panelFX.setExpanded(false);
            panelFX.setTitle("FX");
            XContainer.add(panelFX);
            panelFX.add(new AbstractAction("mirroring") {

                public void actionPerformed(ActionEvent e) {
                    mirror = (mirror == Sprite.NONE) ? ((Integer) requestUserActionDialog("Choose orientation:", new Integer[]{new Integer(Animation.HORIZONTAL), new Integer(Animation.VERTICAL), new Integer(Animation.NONE)}, mirror)).intValue() : Sprite.NONE;
                    currentAnim.setFlipEnabled(true, mirror);
                    mirror_str.setText((mirror == Sprite.NONE) ? "disabled" : "enabled");
                }
            });
            panelFX.add(mirror_str = new JLabel((mirror == Sprite.NONE) ? "disabled" : "enabled"));

            panelFX.add(new AbstractAction("reverse") {

                public void actionPerformed(ActionEvent e) {
                    reverse = (reverse) ? false : true;
                    currentAnim.setReverseEnabled(reverse);
                    reverse_str.setText((reverse) ? "enabled" : "disabled");
                }
            });
            panelFX.add(reverse_str = new JLabel((reverse) ? "enabled" : "disabled"));


            final JFrame printFrame = new JFrame("Print config.");
            printFrame.setLayout(new GridBagLayout());
            JButton sw_print;
            panel.add(new AbstractAction("print...") {

                public void actionPerformed(ActionEvent e) {
                    printFrame.setVisible(!printFrame.isVisible());
                }
            });
            // maps config panel
            JXTaskPane panelMaps = new JXTaskPane();
            panelMaps.setExpanded(false);
            XContainer.add(panelMaps);
            panelMaps.setTitle("Animation Maps");

            panelMaps.add(new AbstractAction("give ID...") {

                public void actionPerformed(ActionEvent e) {
                    if (animsID != null && sfxID != null) {
                        animsID[getCurrentAnim()] = sfxID[getCurrentSfx()] = (String) requestUserActionDialog("Select ID", character.animsID, animsID[getCurrentAnim()]);
                    }
                }
            });
            panelMaps.add(new AbstractAction("select this character's animation by ID...") {

                public void actionPerformed(ActionEvent e) {
                    String name = (String) requestUserActionDialog("Select ID", character.animsID, animsID[getCurrentAnim()]);
                    if (name != null) {
                        animsID[character.anim(name)] = name;
                        sw_anim.setValue(new Integer(character.anim(name)));
                    }
                }
            });
            panelMaps.add(new AbstractAction("select this character's sfx by ID...") {

                public void actionPerformed(ActionEvent e) {
                    String name = (String) requestUserActionDialog("Select ID", character.animsID, sfxID[getCurrentSfx()]);
                    if (name != null) {
                        sfxID[character.sound(name)] = name;
                        sw_sfx.setValue(new Integer(character.sound(name)));
                    }
                }
            });
            panelMaps.add(new AbstractAction("print maps to log") {

                public void actionPerformed(ActionEvent e) {
                    StringBuffer strBuf = new StringBuffer();
                    Formatter formatter = new Formatter(strBuf);
                    for (int i = 0; i < animsID.length; i++) {
                        if (animsID[i] != null) {
                            formatter.format(sw_formatPrintID.getText(), animsID[i], i);
                        }
                    }
                    for (int i = 0; i < sfxID.length; i++) {
                        if (sfxID[i] != null) {
                            formatter.format(sw_formatPrintSfxID.getText(), sfxID[i], i);
                        }
                    }
                    char[] chars = new char[strBuf.length()];
                    strBuf.getChars(0, strBuf.length(), chars, 0);
                    sw_log.pushNewLog(new String(chars));
                }
            });
            panelMaps.add(new AbstractAction("set reverse this character's animation") {

                public void actionPerformed(ActionEvent e) {
                    reversedAnims[getCurrentAnim()] = animsID[getCurrentAnim()] = sfxID[getCurrentSfx()] = (String) requestUserActionDialog("Select ID", character.animsID, animsID[getCurrentAnim()]);
                }
            });
            JXPanel panelPrint = new JXPanel(true);
            panelPrint.setLayout(new GridBagLayout());
            panelPrint.add(sw_formatPrintID = new JTextField("%1$s -> %2$s%n"));
            panelPrint.add(new JLabel("Format print: (%1$=anim ID, %2$=anim n°)"));
            c.fill = GridBagConstraints.HORIZONTAL;
            c.gridheight = GridBagConstraints.SOUTH;
            c.gridwidth = GridBagConstraints.REMAINDER;
            ((GridBagLayout) panelPrint.getLayout()).setConstraints(sw_formatPrintID, c);
            panelPrint.add(sw_formatPrintSfxID = new JTextField("%1$s -> %2$s%n"));
            panelPrint.add(new JLabel("Format print: (%1$=anim ID, %2$=sfx n°)"));
            c.fill = GridBagConstraints.HORIZONTAL;
            c.gridheight = GridBagConstraints.SOUTH;
            c.gridwidth = GridBagConstraints.REMAINDER;
            ((GridBagLayout) panelPrint.getLayout()).setConstraints(sw_formatPrintSfxID, c);

            // log
            final JFrame logFrame = new JFrame("Log area");
            //logFrame.getContentPane().setLayout(new GridBagLayout());
            c.fill = GridBagConstraints.BOTH;
            c.weightx = 1.0;
            c.weighty = 1;
            c.gridheight = GridBagConstraints.CENTER;
            c.gridwidth = GridBagConstraints.CENTER;
            sw_log = new LogArea("--- log stack ---\n");
            JMenuBar jmb = new JMenuBar();
            jmb.add(sw_log.getActionMenu());
            logFrame.setJMenuBar(jmb);
            logFrame.getContentPane().add(sw_log);
            //((GridBagLayout)logFrame.getContentPane().getLayout()).setConstraints(sw_log, c);
            logFrame.setLocationRelativeTo(this);
            logFrame.pack();
            logFrame.setSize(200, 200);

            panel.add(new AbstractAction("log open/close...") {

                public void actionPerformed(ActionEvent e) {
                    logFrame.setVisible(!logFrame.isVisible());
                }
            });


            printFrame.getContentPane().add(panelPrint);
            printFrame.setLocationRelativeTo(this);
            printFrame.pack();

            // customize frame dialog
            final JFrame customizeFrame = new JFrame("Customize character");
            customizeFrame.setLayout(new BorderLayout());
            AbstractAction action_customize_ok = new AbstractAction("Do you apply to the custom values?") {

                public void actionPerformed(ActionEvent e) {
                    switch (JOptionPane.showConfirmDialog(customizeFrame, "Should I use the current customized values?")) {
                        case JOptionPane.OK_OPTION:
                            character = getCustomValues();
                            customizeFrame.setVisible(false);
                            reset();
                            break;
                        case JOptionPane.NO_OPTION:
                            customizeFrame.setVisible(false);
                            break;
                        default:
                            break;
                    }
                }
            };
            customizeFrame.getContentPane().add(new JButton(action_customize_ok), BorderLayout.SOUTH);
            // customize panel
            // scroll expanded panelcustom
            final JScrollPane jsp = new JScrollPane();
            JXPanel panelCustomize = new JXPanel(new GridBagLayout(), true);
            panelCustom = new JXPanel(new GridBagLayout(), true);
            jsp.add(panelCustom);
            panelCustomize.add(jsp);
            jsp.setPreferredSize(new Dimension(200, 200));
            c.weighty = 1;
            c.fill = GridBagConstraints.BOTH;
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(jsp, c);

            panelCustomize.setBorder(new TitledBorder(BorderFactory.createRaisedBevelBorder(), "customize"));
            c.gridwidth = GridBagConstraints.REMAINDER;
            c.fill = GridBagConstraints.BOTH;

            panel.add(new AbstractAction("customize character...") {

                public void actionPerformed(ActionEvent e) {
                    customizeFrame.setVisible((customizeFrame.isVisible()) ? false : true);
                    GridBagConstraints c = new GridBagConstraints();
                    if (character.id != null) {
                        sw_chr_name.setText(character.id);
                    }
                    if (character.floorDiff != 0) {
                        sw_chr_floor.setValue(character.floorDiff);
                    }
                    if (character.spriteHeight != 0) {
                        sw_chr_dim_ext_h.setValue(character.spriteHeight);
                    }
                    if (character.spriteWidth != 0) {
                        sw_chr_dim_ext_w.setValue(character.spriteWidth);
                    }
                    if (character.spriteSize != null) {
                        sw_chr_dim_int_w.setValue(character.spriteSize.width);
                        sw_chr_dim_int_h.setValue(character.spriteSize.height);
                    }
                    if (character.frames != null) {
                        for (int[] anim : character.frames) {
                            panelCustom.add(sw_anim_added_st.push(new JTextField("" + anim[0])));
                            panelCustom.add(sw_anim_added_end.push(new JTextField("" + anim[1])));
                            c.gridwidth = GridBagConstraints.RELATIVE;
                            c.fill = GridBagConstraints.HORIZONTAL;
                            ((GridBagLayout) panelCustom.getLayout()).setConstraints(sw_anim_added_st.peek(), c);
                            c.gridwidth = GridBagConstraints.REMAINDER;
                            ((GridBagLayout) panelCustom.getLayout()).setConstraints(sw_anim_added_end.peek(), c);
                            panelCustom.validate();
                            jsp.validate();
                            repaint();
                        }
                    }
                    if (character.sfx != null) {
                        for (String sfx : character.sfx) {
                            panelCustom.add(sw_sfx_added.push(new JTextField(sfx)));
                            c.fill = GridBagConstraints.HORIZONTAL;
                            ((GridBagLayout) panelCustom.getLayout()).setConstraints(sw_sfx_added.peek(), c);
                            panelCustom.validate();
                            jsp.validate();
                            repaint();
                        }
                    }
                    if (currentAnim instanceof Animation) {
                        sw_anim_input_start.setText("" + currentAnim.getStartingFrame());
                        sw_anim_input_end.setText("" + currentAnim.getStartingFrame() + currentAnim.length);
                        sw_anim_input_prefix.setText(currentAnim.getPrefix());
                        sw_anim_input_suffix.setText(currentAnim.getSuffix());
                        sw_anim_input_size_width.setText("" + currentAnim.getSize().width);
                        sw_anim_input_size_height.setText("" + currentAnim.getSize().height);
                    }
                    jsp.validate();
                }
            });

            panel.add(new AbstractAction("Make customized character .sc3 file...") {

                public void actionPerformed(ActionEvent e) {
                    makeCustom();
                }
            });

            panelCustomize.add(new JLabel("character's name :"));
            panelCustomize.add(sw_chr_name = new JTextField("myCharacter"));
            panelCustomize.add(new JLabel("Distance from the floor to first pixel of image (px) :"));
            panelCustomize.add(sw_chr_floor = new JSpinner(new SpinnerNumberModel(0, 0, 1000, 1)));
            panelCustomize.add(new JLabel("External dimensions of the sprites images (px) WIDTH:"));
            panelCustomize.add(sw_chr_dim_ext_w = new JSpinner(new SpinnerNumberModel(0, 0, 2000, 1)));
            panelCustomize.add(new JLabel("External dimensions of the sprites images (px) HEIGHT:"));
            panelCustomize.add(sw_chr_dim_ext_h = new JSpinner(new SpinnerNumberModel(0, 0, 2000, 1)));
            panelCustomize.add(new JLabel("Internal dimensions of the sprites in the images (px) WIDTH:"));
            panelCustomize.add(sw_chr_dim_int_w = new JSpinner(new SpinnerNumberModel(0, 0, 2000, 1)));
            panelCustomize.add(new JLabel("Internal dimensions of the sprites in the images (px) HEIGHT:"));
            panelCustomize.add(sw_chr_dim_int_h = new JSpinner(new SpinnerNumberModel(0, 0, 2000, 1)));
            panelCustomize.add(sw_anim_input = new JButton("First set directories..."));
            panelCustomize.add(sw_anim_input_start = new JTextField("start frame file n"));
            panelCustomize.add(sw_anim_input_end = new JTextField("end frame file n"));
            panelCustomize.add(new JLabel("Input width:"));
            panelCustomize.add(sw_anim_input_size_width = new JTextField("300"));
            panelCustomize.add(new JLabel("Input height:"));
            panelCustomize.add(sw_anim_input_size_height = new JTextField("300"));
            panelCustomize.add(new JLabel("Input custom prefix:"));
            panelCustomize.add(sw_anim_input_prefix = new JTextField());
            panelCustomize.add(new JLabel("Input custom suffix:"));
            panelCustomize.add(sw_anim_input_suffix = new JTextField());
            panelCustomize.add(new JLabel("Input custom sfx filename:"));
            panelCustomize.add(sw_sfx_input = new JTextField());
            panelCustomize.add(new JLabel("To make a custom model: "));
            panelCustomize.add(sw_anim_add = new JButton("Add new animation v"));
            sw_anim_add.addActionListener(new ActionListener() {

                GridBagConstraints c = new GridBagConstraints();

                public void actionPerformed(ActionEvent actionEvent) {
                    panelCustom.add(sw_anim_added_st.push(new JTextField("animation frame start n")));
                    panelCustom.add(sw_anim_added_end.push(new JTextField("animation frame end n")));
                    c.gridwidth = GridBagConstraints.RELATIVE;
                    c.fill = GridBagConstraints.HORIZONTAL;
                    ((GridBagLayout) panelCustom.getLayout()).setConstraints(sw_anim_added_st.peek(), c);
                    c.gridwidth = GridBagConstraints.REMAINDER;
                    ((GridBagLayout) panelCustom.getLayout()).setConstraints(sw_anim_added_end.peek(), c);
                    panelCustom.validate();
                    jsp.validate();
                    repaint();
                }
            });
            panelCustomize.add(sw_sfx_add = new JButton("Add new sfx v"));
            sw_sfx_add.addActionListener(new ActionListener() {

                GridBagConstraints c = new GridBagConstraints();

                public void actionPerformed(ActionEvent actionEvent) {
                    panelCustom.add(sw_sfx_added.push(new JTextField("sfx filename")));
                    c.gridwidth = ((sw_sfx_added.size() % 2) == 1) ? GridBagConstraints.REMAINDER : GridBagConstraints.RELATIVE;
                    c.fill = GridBagConstraints.HORIZONTAL;
                    ((GridBagLayout) panelCustom.getLayout()).setConstraints(sw_sfx_added.peek(), c);
                    panelCustom.validate();
                    jsp.validate();
                    repaint();
                }
            });
            sw_anim_input.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    try {
                        action_setDirectory.actionPerformed(e);
                        action_setSFXDirectory.actionPerformed(e);
                        String start = sw_anim_input_start.getText();
                        String end = sw_anim_input_end.getText();
                        int startFrame = Integer.valueOf(start);
                        int endFrame = Integer.valueOf(end);
                        character = SpritesChar.getCustomSpritesChar(resolution);
                        character.frames = new int[][]{{startFrame, endFrame}};
                        character.spriteWidth = Integer.valueOf(sw_anim_input_size_width.getText());
                        character.spriteHeight = Integer.valueOf(sw_anim_input_size_height.getText());
                        character.prefix = sw_anim_input_prefix.getText();
                        character.suffix = sw_anim_input_suffix.getText();
                        character.sfx = new String[]{sw_sfx_input.getText()};
                    } catch (Exception ex) {
                        ex.printStackTrace();
                        new UIMessage(true, ex.getMessage(), customizeFrame);
                    }
                }
            });
            c.fill = GridBagConstraints.HORIZONTAL;
            c.gridwidth = GridBagConstraints.RELATIVE;
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_anim_input_start, c);
            c.gridwidth = GridBagConstraints.REMAINDER;
            c.weighty = 0.5;
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_chr_dim_ext_h, c);
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_chr_dim_ext_w, c);
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_chr_dim_int_h, c);
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_chr_dim_int_w, c);
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_chr_floor, c);
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_chr_name, c);
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_anim_input, c);
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_anim_input_end, c);
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_anim_input_size_width, c);
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_anim_input_size_height, c);
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_anim_input_prefix, c);
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_anim_input_suffix, c);
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_sfx_input, c);
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_anim_add, c);
            ((GridBagLayout) panelCustomize.getLayout()).setConstraints(sw_sfx_add, c);


            customizeFrame.getContentPane().add(panelCustomize, BorderLayout.CENTER);
            customizeFrame.setLocationRelativeTo(this);
            customizeFrame.pack();

            panel.add(new AbstractAction("make customized character's .mc3 file model...") {

                public void actionPerformed(ActionEvent e) {
                    makeModel();
                }
            });

            panel.add(new AbstractAction("load from .mc3 model...") {

                public void actionPerformed(ActionEvent e) {
                    loadModel();
                }
            });

            final JXPanel paramFrame = new JXPanel(true);
            paramFrame.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(), "Parameters config.", TitledBorder.RIGHT, TitledBorder.TOP));
            paramFrame.add(XContainer);
            JScrollPane sp2;
            sp2 = new JScrollPane();
            sp2.add(paramFrame);
            sp2.setSize((int) (getSize().width / 3), getSize().height);
            add(sp2, BorderLayout.WEST);
            // bounds
            initScene();
            // Keyboard
            KeyEventDispatcher ked = new KeyEventDispatcher() {

                public boolean dispatchKeyEvent(KeyEvent e) {
                    System.out.println("AnimsBrowser_Ant dispatched KeyEvent");
                    if (e.getID() == KeyEvent.KEY_PRESSED) {
                        if (e.getModifiers() == KeyEvent.ALT_MASK) {
                            switch (e.getKeyCode()) {
                                case KeyEvent.VK_P:
                                    action_play.actionPerformed(null);
                                    break;
                                case KeyEvent.VK_UP:
                                    loadNextAnim();
                                    break;
                                case KeyEvent.VK_DOWN:
                                    loadPreviousAnim();
                                    break;
                                default:
                                    break;
                            }
                        }
                    }
                    return true;
                }
            };
            KeyboardFocusManager.getCurrentKeyboardFocusManager().addKeyEventDispatcher(ked);
            initialized = true;

            validate();
            setVisible(true);
            scene.resume();
        } catch (AccessControlException e) {
            System.out.println("Access denied to file system.");
        }
    }

    private Custom getCustomValues() {
        int[][] newFrames = new int[sw_anim_added_st.size()][2];
        int i = 0;
        for (JTextField start : sw_anim_added_st) {
            newFrames[i][0] = Integer.parseInt(start.getText());
            for (JTextField end : sw_anim_added_end) {
                newFrames[i][1] = Integer.parseInt(end.getText());
            }
            i++;
        }
        String[] sfxFiles = new String[sw_sfx_added.size()];
        i = 0;
        for (JTextField file : sw_sfx_added) {
            sfxFiles[i] = file.getText();
        }
        Custom custom = SpritesChar.getCustomSpritesChar(sw_chr_name.getText(), resolution, ((SpinnerNumberModel) sw_chr_floor.getModel()).getNumber().intValue(), new Dimension(((SpinnerNumberModel) sw_chr_dim_ext_w.getModel()).getNumber().intValue(), ((SpinnerNumberModel) sw_chr_dim_ext_h.getModel()).getNumber().intValue()), new Dimension(((SpinnerNumberModel) sw_chr_dim_int_w.getModel()).getNumber().intValue(), ((SpinnerNumberModel) sw_chr_dim_int_h.getModel()).getNumber().intValue()), newFrames, reversedAnims, sfxID);
        for (int j = 0; j < animsID.length; j++) {
            if (animsID[j] != null) {
                custom.addAnimMap(animsID[j], j);
            }
        }
        for (int j = 0; j < sfxID.length; j++) {
            if (sfxID[j] != null) {
                custom.addSoundMap(sfxID[j], j);
            }
        }
        return custom;
    }

    private void loadCustom() {
        File[] f = getFiles(new String[]{"sc3"});
        if (f == null) {
            return;
        }
        ObjectInputStream ois = null;
        Custom custom = null;
        try {
            ois = new ObjectInputStream(new FileInputStream(f[0]));
            custom = (Custom) ois.readObject();
            ois.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            ois = null;
            if (custom instanceof Custom) {
                new UIMessage(true, "Custom model fully loaded$! " + custom, null);
                character = custom;
            } else {
                new UIMessage(true, "Nothing to load! " + f[0], null);
            }
        }
    }

    private void makeCustom() {
        String[] savePath = getDirectory();
        if (savePath[0] != null) {
            Custom custom = getCustomValues();
            boolean write = false;
            ObjectOutputStream oos = null;
            try {
                oos = new ObjectOutputStream(new FileOutputStream(new File(savePath[0] + File.separator + custom.id + ".sc3")));
                oos.writeObject(custom);
                write = true;
                oos.close();
            } catch (Exception ex) {
                ex.printStackTrace();
                write = false;
            } finally {
                oos = null;
                System.out.println(savePath[0] + " :" + ((write) ? "CUSTOM MODEL WRITE OK! " : "CUSTOM MODEL WRITE FAILED!"));
                if (write) {
                    Custom customRead = null;
                    ObjectInputStream ois = null;
                    try {
                        ois = new ObjectInputStream(new FileInputStream(new File(savePath[0] + File.separator + custom.id + ".sc3")));
                        customRead = (Custom) ois.readObject();
                        ois.close();
                    } catch (Exception ex2) {
                        ex2.printStackTrace();
                    } finally {
                        ois = null;
                        if (customRead != null) {
                            new UIMessage(true, customRead.toString(), null);
                        } else {
                            new UIMessage(true, "Impossible to read customized model!!!", null);
                        }
                    }
                }
            }
        }
    }

    private void makeModel() {
        if (character == null) {
            return;
        }
        SpritesCacheManager mc3 = new SpritesCacheManager<Integer, Animation>(character.frames.length);
        mainCache.buffer(mc3);
        mc3.setAutoCleanupEnabled(false);
        mc3.setCompressionEnabled(false);
        mc3.setSwapDiskEnabled(true);
        int res = getResolution();
        String path = getDirectory()[0] + File.separator + character.id + ".mc3";
        if (path == null) {
            return;
        }
        int i = 0;
        for (int[] anim : character.frames) {
            String animID = null;
            Set<Map.Entry<String, Integer>> set = ((Custom) character).animsMap.entrySet();
            synchronized (((Custom) character).animsMap) {
                for (Iterator<Map.Entry<String, Integer>> entries = set.iterator(); entries.hasNext();) {
                    Map.Entry<String, Integer> entry = entries.next();
                    if (entry.getValue().equals(i)) {
                        animID = entry.getKey();
                        break;
                    }
                }
            }
            Animation animation = null;
            if (spritesDir != null && spritesExt != null) {
                try {
                    animation = new Animation(spritesDir,
                            false,
                            anim[0],
                            anim[1],
                            character.prefix,
                            character.suffix + "." + spritesExt,
                            format,
                            new Dimension(character.getWidth(res), character.getHeight(res)));
                    if (animID != null) {
                        animation.setSfx(sfxDir + File.separator + character.sfx[character.sound(animID)], false, 0);
                    }
                    animation.setSwapDiskCacheEnabled(false);
                    mc3.add(i++, animation);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }
        // once loaded, write model
        ObjectOutputStream oos = null;
        FileOutputStream fos = null;
        ObjectInputStream ois = null;
        FileInputStream fis = null;
        try {
            oos = new ObjectOutputStream(fos = new FileOutputStream(new RandomAccessFile(path, "rws").getFD()));
            mainCache.buffer(oos);
            // write sprites cache
            oos.writeObject(mc3);
            oos.close();
            fos.close();
        } catch (Exception ex2) {
            ex2.printStackTrace();
            new UIMessage(true, "Model may not be stored to " + path + " ! error: " + ex2.getMessage(), null);
        } finally {
            // sprite should have stored so we try to recover it from path
            try {
                oos = null;
                fos = null;
                mc3.cleanFileSwap();
                mc3 = null;
                mainCache.cleanup();
                ois = new ObjectInputStream(fis = new FileInputStream(new RandomAccessFile(path, "r").getFD()));
                mainCache.buffer(ois);
                mc3 = (SpritesCacheManager) ois.readObject();
                mainCache.buffer(mc3);
                ois.close();
                fis.close();
            } catch (Exception ex3) {
                ex3.printStackTrace();
            } finally {
                ois = null;
                fis = null;
                mainCache.cleanup();
                if (mc3 instanceof SpritesCacheManager) {
                    new UIMessage(true, "Model's been successfully stored to " + path + " !", null);
                }
            }
        }
    }

    private void loadModel() {
        File[] f = getFiles(new String[]{"mc3"});
        if (f == null) {
            return;
        }
        ObjectInputStream ois = null;
        SpritesCacheManager<Integer, Animation> mc3 = null;
        try {
            ois = new ObjectInputStream(new FileInputStream(new RandomAccessFile(f[0], "r").getFD()));
            mc3 = (SpritesCacheManager) ois.readObject();
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            if (ois != null) {
                try {
                    ois.close();
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
            }
            if (mc3 instanceof SpritesCacheManager) {
                new UIMessage(true, "Model fully loaded$! " + mc3, null);
                model = mc3;
                Thread t = new Thread(new Runnable() {

                    public void run() {
                        try {
                            loadModelPanel(model);
                        } catch (InterruptedException e) {
                            new UIMessage(true, e.getMessage(), null);
                        }
                    }
                });
                t.setPriority(Thread.MAX_PRIORITY);
                t.start();
            } else {
                new UIMessage(true, "Nothing to load! " + f[0], null);
            }
        }
    }

    /***/
    private void loadModelPanel(SpritesCacheManager<Integer, Animation> mc3) throws InterruptedException {
        modelPanel.removeAll();
        final SpritesCacheManager<Integer, Animation> model = mc3;
        GridBagConstraints c = new GridBagConstraints();
        c.gridwidth = GridBagConstraints.REMAINDER;
        Map<Integer, File> cache = mc3.getSwapMap();
        int width = 3;
        int n = 0;
        for (Integer key : cache.keySet()) {
            final int record = key;
            Animation current = mc3.get(key);
            final JXImagePanel anim = new JXImagePanel();
            anim.addMouseListener(new MouseAdapter() {

                public void mouseClicked(MouseEvent e) {
                    currentAnim = model.get(record);
                    anim.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED, Color.BLUE, Color.GREEN));
                }
            });
            anim.setDoubleBuffered(true);
            anim.setImage(current.getImage((Component) scene));
            anim.setPreferredSize(current.getSize());
            anim.setStyle(JXImagePanel.Style.SCALED);
            JXTitledPanel panel = new JXTitledPanel(current.getStartingFrame() + " - " + (current.getStartingFrame() + current.length) + " (" + current.realTimeLength() + "ms)", anim);
            panel.setPreferredSize(new Dimension(current.getSize().width, current.getSize().height + 10));
            modelPanel.add(panel);
            if ((n % width) == (width - 1)) {
                ((GridBagLayout) modelPanel.getLayout()).setConstraints(panel, c);
            }
            modelPanel.validate();
            n++;
        }
    }

    private void removeScene() {
        if (scene != null) {
            scene.suspend();
            remove(scene);
        }
        mainCache.cleanup();
    }

    private void layoutScene() {
        add(scene, BorderLayout.CENTER);
        scene.resume();
    }

    /***/
    private void initScene() {
        removeScene();
        scene = new RenderingScene(new Dimension((int) (getSize().width / 3), getSize().height));
        scene.addActionBefore(new AbstractAction() {

            public void actionPerformed(ActionEvent e) {
                stateAnimation();
                try {
                    drawAnim();
                } catch (InterruptedException ex) {
                    ex.printStackTrace();
                }
            }
        });
        scene.addActionAfter(new AbstractAction() {

            public void actionPerformed(ActionEvent e) {
                repaint();
            }
        });
        mainCache.buffer(scene);
        scene.addListener(this);
        layoutScene();
    }

    /**
     * Datas are initialized such as animations ids and screen buffer, as well as refresh Timer.
     * @discussion It is called by the load button on panel and naturally at init().
     */
    private void initData() {
        this.mt = new SfMediaTracker(this);
        initScene();
        panel.setTitle(character.id + " (" + format + ")");
        animsID = new String[character.frames.length];
        sfxID = new String[character.frames.length];
        reversedAnims = new String[character.frames.length];
        model = new SpritesCacheManager<Integer, Animation>(character.frames.length);
        model.setSwapDiskEnabled(swap);
        model.addSpritesCacheListener(new SpritesCacheListener() {

            public void capacityExtended(int newCapacity) {
                statusBar.setValue((int) model.allocSize());
            }

            public void readAborted() {
            }

            public void readCompleted() {
                statusBar.setValue((int) model.allocSize());
            }

            public void readError(StackTraceElement[] trace) {
                statusBar.setValue((int) model.allocSize());
            }

            public void readStarted() {
            }

            public void writeAborted() {
            }

            public void writeCompleted() {
                statusBar.setValue((int) model.allocSize());
            }

            public void writeError(StackTraceElement[] trace) {
                statusBar.setValue((int) model.allocSize());
            }

            public void writeStarted() {
            }
        });
        // swing compoments
        if (sw_anim != null) {
            sw_anim.setModel(new SpinnerNumberModel(0, 0, character.frames.length - 1, 1));
        }
        if (sw_sfx != null) {
            sw_sfx.setModel(new SpinnerNumberModel(0, 0, character.sfx.length - 1, 1));
        }
    }

    /**
     * This refreshes anim spot in applet content.
     * @discussion (comprehensive description)
     */
    private void refreshSpot() {
        if (currentAnim instanceof Animation) {
            statusBar.setValue((int) currentAnim.allocSize());
        }
        box = scene.getBounds();
    }

    /**
     * Returns current sound fx index, associated to animation id.
     * @discussion (comprehensive description)
     * @return		integer value, the index of current sfx
     */
    private int getCurrentSfx() {
        return ((SpinnerNumberModel) sw_sfx.getModel()).getNumber().intValue();
    }

    /**
     * Returns AudioClip instances associated to current sfx index.
     * @discussion (comprehensive description)
     * @return		an audio clip instance, is used to play animation sfx
     */
    private String getSfx() {
        int n = getCurrentSfx();
        File f = null;
        if (n <= (character.sfx.length - 1)) {
            f = new File(sfxDir + File.separator + character.sfx[n]);
            return f.getPath();
        } else {
            return null;
        }
    }

    /**
     * Loads a dialog with all of the optional colors, then returns user selected Color.
     * @discussion (comprehensive description)
     * @return		the selected Color instance
     */
    private Color getColor() {
        return (Color) requestUserActionDialog("Select background color: ", new Color[]{Color.BLUE, Color.RED, Color.ORANGE, Color.YELLOW, Color.WHITE, Color.BLACK, Color.GRAY, Color.GREEN}, bgColor);
    }

    /**
     * Loads a dialog with all of the optional characters (from SpritesChars src), then returns user selected SpritesChar.
     * @discussion (comprehensive description)
     * @return		the selected SpritesChar instance
     */
    private SpritesChar getSpritesChar() {
        SpritesChar[] allCharacters = new SpritesChar[SpritesChar.characters.size()];
        int i = 0;
        for (Object e : SpritesChar.characters.entrySet().toArray()) {
            allCharacters[i++] = (SpritesChar) ((Map.Entry) e).getValue();
        }
        return (SpritesChar) requestUserActionDialog("Select character to anim:", allCharacters, character);
    }

    /***/
    private int getResolution() {
        return ((Map.Entry<Integer, String>) requestUserActionDialog("Select resolution of the sprites to serialize:", character.RES_NAMES_map.entrySet().toArray(), null)).getKey();
    }

    /** fetch files from disk*/
    private File[] getFiles(String[] exts) {
        if (scene != null) {
            scene.suspend();
        }
        FileChooserPane fcp = new FileChooserPane(null, "");
        HashSet ext = new HashSet();
        for (String extName : exts) {
            ext.add(extName);
        }
        fcp.addFileFilter(ext);
        return fcp.getFile();
    }

    /**
     * Loads a FileChooser dialog, then returns user selected Directory with file extension.
     * @discussion (comprehensive description)
     * @return an array of strings containing [0] directory and [1] file extension, can have null entries if nothing is chosen by the user
     */
    private String[] getDirectory() {
        this.dirSelect = new FileChooserPane(null, spritesDir = (spritesDir == null) ? "." : spritesDir);
        dirSelect.setMultiSelectionEnabled(false);
        File[] dir = dirSelect.getDirectory();
        return new String[]{(dir != null) ? dir[0].getPath() : null, (format = getFormat()).substring(format.lastIndexOf('/') + 1)};
    }

    /**
     * Returns current animation selected number. Depends on animations JSpinner in panel.
     * @discussion (comprehensive description)
     * @return		integer value, the index of the current anim
     */
    private int getCurrentAnim() {
        return ((SpinnerNumberModel) sw_anim.getModel()).getNumber().intValue();
    }

    /***/
    private int getNextAnim() {
        return (Integer) ((SpinnerNumberModel) sw_anim.getModel()).getNextValue();
    }

    /***/
    private int getPreviousAnim() {
        return (Integer) ((SpinnerNumberModel) sw_anim.getModel()).getPreviousValue();
    }

    /***/
    private void loadNextAnim() {
        sw_anim.setValue(getNextAnim());
        loadAnim(mt, getSfx());
    }

    /***/
    private void loadPreviousAnim() {
        sw_anim.setValue(getPreviousAnim());
        loadAnim(mt, getSfx());
    }

    /**
     * Loads Animation instances to the choosen one in panel.
     * @discussion (comprehensive description)
     * @param		mt MediaTracker used to control animations frames load
     * @param		sfx AudioClip associated to the Animation loaded here
     */
    private synchronized Animation loadAnim(MediaTracker mt, String sfx) {
        scene.suspend();
        int n = getCurrentAnim();
        Animation newAnim = null;
        if (currentAnim != null) {
            currentAnim.clearResource();
        }
        Dimension spriteSize = new Dimension(character.getWidth(resolution), character.getHeight(resolution));
        try {
            if (spritesDir != null && spritesExt != null) {
                if (n < character.frames.length) {

                    newAnim = new Animation(spritesDir,
                            false,
                            character.frames[n][0],
                            character.frames[n][1],
                            character.prefix,
                            character.suffix + "." + spritesExt,
                            format,
                            spriteSize);
                    newAnim.setSfx(sfx, false, 0);

                }
            } else {
                newAnim = new Animation(30, format, spriteSize);
            }
            newAnim.setReverseEnabled(reverse);
            newAnim.setFlipEnabled(true, mirror);
            newAnim.setZoomEnabled(true, zoom = sw_zoom.getValue() / 100.0);
            newAnim.setBufferedImageEnabled(true);
            newAnim.setCompressedCacheEnabled(compress);
            newAnim.setSwapDiskCacheEnabled(swap);
            newAnim.setTransformEnabled(true);
            if (newAnim.checkSource()) {
                model.add(n, newAnim);
            }
            if (model.has(n)) {
                currentAnim = model.get(n);
            }
            currentAnim.loadResource();
            scene.resume();
            return currentAnim;
        } catch (Exception e) {
            e.printStackTrace();
            new UIMessage(true, "Animation file not found! " + e.getMessage(), null);
            return null;
        }
    }

    /**
     * Draws animation to the screen buffer for further draw in applet paint() call.
     * @discussion (comprehensive description)
     */
    private void drawAnim() throws InterruptedException {
        GraphicsJAI g2 = Sprite.createGraphicsJAI(scene.getOffscreen().getImage((Component) scene).getGraphics(), scene);
        box = scene.getBounds();
        g2.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_SPEED);
        g2.setColor(bgColor);
        g2.clearRect(box.x, box.y, box.width, box.height);
        g2.setColor(Color.YELLOW);
        if (currentAnim != null) {
            currentAnim.setFlipEnabled(true, mirror);
            currentAnim.setZoomEnabled(true, zoom);
            currentAnim.draw(scene, g2);
            try {
                g2.drawString("playing: " + new Formatter().format("%1$0-2tM'%1$0-2tS\".%1$0-3tL", currentAnim.getTimeFramePosition()), 10, 10);
            } catch (Exception e) {
                e.printStackTrace();
            }
            g2.setFont(new Font("monospaced", Font.BOLD, 50));
            g2.drawString(((SpinnerNumberModel) sw_anim.getModel()).getValue().toString(), 20, 60);
            g2.setFont(new Font("monospaced", Font.BOLD | Font.ITALIC, 12));
            g2.drawString(currentAnim + " ID: " + animsID[getCurrentAnim()], 10, box.height - 20);
        }
    }

    /**
     * Pops up a dialog to select options values. Returns an Object to cast.
     * @discussion (comprehensive description)
     * @param		actionMsg This dialog action name
     * @param		options Object array with the selectable options
     * @param		init Object that will be initialy selected in tray
     * @return		selected object, cast it to the options common class
     */
    private Object requestUserActionDialog(String actionMsg, Object[] options, Object init) {
        if (scene != null) {
            scene.suspend();
        }
        JOptionPane userActionDialog = new JOptionPane(actionMsg, JOptionPane.QUESTION_MESSAGE, JOptionPane.OK_CANCEL_OPTION);
        userActionDialog.setSelectionValues(options);
        userActionDialog.setInitialSelectionValue(init);
        userActionDialog.setWantsInput(true);
        Dialog dialog = userActionDialog.createDialog(this, "Option");
        dialog.setModal(true);
        dialog.setVisible(true);
        return userActionDialog.getInputValue();
    }

    /***
     */
    private void stateAnimation() {
        String state = "";
        if (currentAnim != null) {
            switch (currentAnim.status()) {
                case Animation.PLAYING:
                    state = "PLAYING";
                    break;
                case Animation.STOPPED:
                    state = "STOPPED";
                    break;
                case Animation.PAUSED:
                    state = "PAUSED";
                    break;
                default:
                    state = "Can't status Animation!";
                    break;
            }
        }
        if (sw_state != null) {
            sw_state.setText(state);
        }
        System.out.println(state);
        panel.repaint();
    }

    public void setOwner(Frame owner) {
        this.owner = owner;
    }
    private Frame owner = null;

    public void setVisible(boolean b) {
        super.setVisible(b);
    //main.setVisible(b);
    }

    /** main command to java launcher */
    public static void main(String[] args) throws IOException {
        new AnimsBrowser_Ant();
    }

    /***/
    public AnimsBrowser_Ant() throws IOException {
        super();
        AppLauncher launch = new AppLauncher(this, "images/AnimsBrowser_Ant.png", new Dimension(800, 600), "about.htm");
    }

    /** called to init the most recent data*/
    public void reset() {
        if (currentAnim != null) {
            currentAnim.cancel();
        }
        initData();
    }

    private String getFormat() {
        return (String) requestUserActionDialog("Choose file extension:", ImageIO.getReaderMIMETypes(), "image/png");
    }

    public Applet getApplet() {
        return this;
    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource() instanceof RenderingScene) {
            layoutScene();
        }
    }

    public void paint(Graphics g) {
        int pty = Thread.currentThread().getPriority();
        Thread.currentThread().setPriority(Thread.MAX_PRIORITY);
        if (offscreen == null) {
            offscreen = Sprite.createBufferedImage(getSize(), Sprite.DEFAULT_TYPE);
        }
        Graphics2D g2D = offscreen.createGraphics();
        g2D.clearRect(0, 0, getSize().width, getSize().height);
        super.paint(g2D);
        ((Graphics2D) g).drawImage(offscreen, null, 0, 0);
        Thread.currentThread().setPriority(pty);
    }

    public boolean open(Object data) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public DataFlavor[] getTransferDataFlavors() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public boolean isDataFlavorSupported(DataFlavor flavor) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException, IOException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public AppLauncher getAppLauncher() {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
