/*
 * KeyEventWrapper.java
 *
 * Created on 30 mai 2007, 05:09
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package net.library.jiga.sf3.system.input;

import java.awt.event.KeyEvent;
import java.io.Serializable;
import java.util.Formatter;
import java.util.Iterator;
import java.util.Vector;

/**
 *
 * @author website
 */
public class KeyEventWrapper implements Serializable, Comparable{
    /***/
    public static final long DEFAULT_TIMING = 0;
    /***/
    public long _timing = 0;
    /***/
    public int _keyCode = -1;
    /***/
    public int _ID = -1;
    /***/
    public Vector<KeyEventWrapper> _sequence = new Vector<KeyEventWrapper>();
    
    /***/
    public KeyEventWrapper(int keyCode, int ID) {
        this(keyCode, ID, DEFAULT_TIMING);
    }
    
    /***/
    public KeyEventWrapper(int keyCode, int ID, long timingMin) {
        this._keyCode = keyCode;
        this._ID = ID;
        this._timing = timingMin;
    }
    
    /***/
    public KeyEventWrapper(Vector<KeyEventWrapper> sequence) {
        this._sequence = sequence;
        this._timing = 0;
        for(Iterator<KeyEventWrapper> i = _sequence.iterator(); i.hasNext();) {
            KeyEventWrapper kew = i.next();
            _timing += kew._timing;
        }
    }
    
    /***/
    public boolean isBlankEvent() {
        return (_ID == -1 && _keyCode == -1 && _sequence.isEmpty());
    }
    
    /***/
    public int hashCode() {
        int sHash = 0;
        for(Iterator<KeyEventWrapper> i = _sequence.iterator(); i.hasNext();)
            sHash += i.next().hashCode();
        return _keyCode + _ID + sHash;
    }
    
    /** timings are significant to compute equality (note that a KeyEvent object can be specified)*/
    public boolean equals(Object o) {
        try{
            return compareTo(o) == 0;
        } catch(NullPointerException e) {
            return false;
        }
    }
    
    /** to make this keyEventWrapper matched by a KeyEvent's or KeyEventWrapper's, it has to return less or equal to zero for the specifed object;
     * a positive value means that either it mismatched the timings or the ID and KeyCode.
     *this Comparable orders by its timings if the KeyCode and ID match the specified object.
     *@throws NullPointerException is thrown if a null object is specified.
     */
    public int compareTo(Object o) {
            if(o == null)
                throw new NullPointerException("KeyEventWrapper cannot be compared to a null object !");
            if(_sequence.isEmpty()) {
                if(o instanceof KeyEvent) {
                    KeyEvent e = (KeyEvent)o;
                    long t = System.currentTimeMillis() - e.getWhen();
                    return (e.getID() == _ID && e.getKeyCode() == _keyCode)?
                        ((t == _timing)?0:((t < _timing)?1:-1)):1;
                } else if(o instanceof KeyEventWrapper) {
                    KeyEventWrapper e = (KeyEventWrapper)o;
                    if(e._sequence.isEmpty())
                        return (e._ID == _ID && e._keyCode == _keyCode)?
                            ((e._timing == _timing)?0:((e._timing < _timing)?1:-1)):1;
                    else
                        return 1;
                    
                } else
                    return 1;
            } else {
                if(o instanceof KeyEventWrapper) {
                    KeyEventWrapper e = (KeyEventWrapper)o;
                    if(e._sequence.isEmpty())
                        return 1;
                    Iterator<KeyEventWrapper> i1 = e._sequence.iterator();
                    Iterator<KeyEventWrapper> i0;
                    int comparator = 0;
                    for(i0 = _sequence.iterator(); i1.hasNext() && i0.hasNext();) {
                        KeyEventWrapper kew0 = i0.next();
                        KeyEventWrapper kew1 = i1.next();
                        if((comparator = (comparator == 0)?kew0.compareTo(kew1):comparator) > 0)
                            return 1;
                        }
                    return (!i1.hasNext() && !i0.hasNext())?comparator:(i1.hasNext())?-1:1;
                } else
                    return 1;
            }
    }
    
    /***/
    public String toString() {
        String s = "";
        for(Iterator<KeyEventWrapper> i = _sequence.iterator(); i.hasNext(); ) {
            KeyEventWrapper kew = i.next();
            s += kew + " - ";
        }
        return getClass().getName() + 
                ((_keyCode != -1)?KeyEvent.getKeyText(_keyCode) + 
                ((_ID == KeyEvent.KEY_PRESSED)?"PRESSED":((_ID == KeyEvent.KEY_RELEASED)?"RELEASED":((_ID == KeyEvent.KEY_TYPED)?"TYPED":""))) +
                " sec." + new Formatter().format("%1$.3f", (float)_timing / 1000f):"") 
                + "{ " + s + "}";
    }
}